#include "vs_othello.h"
#include <string.h>
#include <stdlib.h>
#include <unistd.h>
#include "bitmap/kuro.xbm"
#include "bitmap/shiro.xbm"


void w1_open()
{
    static XSizeHints xsizehints;

    d1 = XOpenDisplay(NULL);
    black1 = BlackPixel(d1,0);
    white1 = WhitePixel(d1,0);
    w1 = XCreateSimpleWindow(d1, RootWindow(d1,0), 100, 100, 600,500, 2, black1,white1);
    XSelectInput(d1, w1, ButtonPressMask | KeyPressMask | ExposureMask);
    gc1 = XCreateGC(d1,w1, 0, 0);
    cmap1 = DefaultColormap(d1, 0);
    p_tile1 = XCreatePixmap(d1,w1,96,50,DefaultDepth(d1,0));
    XSetForeground(d1, gc1, white1);
    XFillRectangle(d1,p_tile1,gc1,0,0,96,50);
    XAllocNamedColor(d1,cmap1,"LightPink",&col,&c0);
    XSetForeground(d1, gc1, col.pixel);
    XSetFont(d1,gc1,XLoadFont(d1, "8x16"));
    XDrawString(d1,p_tile1,gc1,0,24,"VS OTHELLO  ",12);
    XDrawString(d1,p_tile1,gc1,0,49,"ELLO  VS OTH",12);
    XSetWindowBackgroundPixmap(d1,w1,p_tile1);
    XStoreName(d1,w1,"VS OTHELLO");
    xsizehints.flags = (PBaseSize | PMinSize | PMaxSize);
    xsizehints.base_width  = 600;
    xsizehints.base_height = 500;
    xsizehints.min_width   = 600;
    xsizehints.min_height  = 500;
    xsizehints.max_width   = 600;
    xsizehints.max_height  = 500;
    XSetWMNormalHints(d1,w1,&xsizehints);
    XMapWindow(d1, w1);
    do { XNextEvent(d1, &e); } while(e.type!=Expose);
    XDefineCursor(d1,w1,XCreateFontCursor(d1,XC_arrow));

    XFlush(d1);
}

void get_display_name()
{
	static int i,  colon;

	XClearWindow(d1,w1);
    title();
	if(!(opt_d)){
    st = 0;
    str[p] = 0;
    XAllocNamedColor(d1,cmap1,"gray80",&col,&c0);
    XSetForeground(d1, gc1, col.pixel);
	if(p < 13)
	    XDrawString(d1,w1,gc1,416,456,str,p);
	else if(p < 21)
		XDrawString(d1,w1,gc1,306,486,str,p);
	else
		XDrawString(d1,w1,gc1,606-15*p,486,str,p);
        XSetForeground(d1, gc1, black1);
	if(p < 13)
		XDrawString(d1,w1,gc1,410,450,str,p);
	else if (p < 21)
           	XDrawString(d1,w1,gc1,300,480,str,p);
	else
			XDrawString(d1,w1,gc1,600-15*p,480,str,p);
    XFlush(d1);
    while(1){
        XNextEvent(d1,&e);
        if(e.type == Expose){
            title();
            str[p] = 0;
            XAllocNamedColor(d1,cmap1,"gray80",&col,&c0);
            XSetForeground(d1, gc1, col.pixel);
			if(p < 13)
	            XDrawString(d1,w1,gc1,416,456,str,p);
			else if(p < 21)
				XDrawString(d1,w1,gc1,306,486,str,p);
			else
				XDrawString(d1,w1,gc1,606-15*p,486,str,p);
            XSetForeground(d1, gc1, black1);
			if(p < 13)
				XDrawString(d1,w1,gc1,410,450,str,p);
			else if(p < 21)
            	XDrawString(d1,w1,gc1,300,480,str,p);
			else
				XDrawString(d1,w1,gc1,600-15*p,480,str,p);
            XFlush(d1);
            continue;
        }
        else if(e.type == KeyPress){
            if(XLookupString(&e.xkey,string,10,&key,NULL) != 1)continue;
            switch(key){
                case XK_Return :
                    st = 1;
                    break;
                case XK_BackSpace :
                    if(p > 0)str[--p] = 0;
                    break;
                case XK_Shift_R :
                case XK_Shift_L :
                    break;
                default :
                    if( !IsCursorKey(key) && !IsFunctionKey(key) )
                        str[p++] = string[0];
            }
            if(st)break;
            XClearArea(d1,w1,410,400,250,100,False);
            XClearArea(d1,w1,0,458,600,30,False);
            str[p] = 0;
            XAllocNamedColor(d1,cmap1,"gray80",&col,&c0);
            XSetForeground(d1, gc1, col.pixel);
			if(p < 13)
	            XDrawString(d1,w1,gc1,416,456,str,p);
			else if(p < 21)
				XDrawString(d1,w1,gc1,306,486,str,p);
			else
				XDrawString(d1,w1,gc1,606-15*p,486,str,p);
            XSetForeground(d1, gc1, black1);
			if(p < 13)
				XDrawString(d1,w1,gc1,410,450,str,p);
			else if (p < 21)
            	XDrawString(d1,w1,gc1,300,480,str,p);
			else
				XDrawString(d1,w1,gc1,600-15*p,480,str,p);
            XFlush(d1);
        }
    }
	}/*End of if(!(opt_d))*/
	else{
		opt_d = 0;
		p = strlen(str);
        str[p] = 0;
        XAllocNamedColor(d1,cmap1,"gray80",&col,&c0);
        XSetForeground(d1, gc1, col.pixel);
		if(p < 13)
            XDrawString(d1,w1,gc1,416,456,str,p);
		else if(p < 21)
			XDrawString(d1,w1,gc1,306,486,str,p);
		else
			XDrawString(d1,w1,gc1,606-15*p,486,str,p);
        XSetForeground(d1, gc1, black1);
		if(p < 13)
			XDrawString(d1,w1,gc1,410,450,str,p);
		else if (p < 21)
           	XDrawString(d1,w1,gc1,300,480,str,p);
		else
			XDrawString(d1,w1,gc1,600-15*p,480,str,p);
        XFlush(d1);
	}
	colon = 0;
	for(i=0;i<p;i++){
		if(str[i] == ':')colon = 1;
	}
	if(colon)
	    str[p] = 0;
	else{
		strcat(str,":0.0");
		p = strlen(str);
	}
    XDefineCursor(d1,w1,XCreateFontCursor(d1,XC_watch));
    XFlush(d1);
}

void w2_open()
{
    static XSizeHints xsizehints;
	static int i;
	static char stmp[128];

    d2 = XOpenDisplay(str);
    black2 = BlackPixel(d2,0);
    white2 = WhitePixel(d2,0);
    w2 = XCreateSimpleWindow(d2, RootWindow(d2,0), 400, 400, 600,500, 2, black2,white2);
    XSelectInput(d2, w2, ButtonPressMask | ExposureMask);
    gc2 = XCreateGC(d2,w2, 0, 0);
    cmap2 = DefaultColormap(d2, 0);
    p_tile2 = XCreatePixmap(d2,w2,96,50,DefaultDepth(d2,0));
    XSetForeground(d2, gc2, white2);
    XFillRectangle(d2,p_tile2,gc2,0,0,96,50);
    XAllocNamedColor(d2,cmap2,"LightSkyBlue",&col,&c0);
    XSetFont(d2,gc2,XLoadFont(d2, "8x16"));
    XSetForeground(d2, gc2, col.pixel);
    XDrawString(d2,p_tile2,gc2,0,24,"VS OTHELLO  ",12);
    XDrawString(d2,p_tile2,gc2,0,49,"ELLO  VS OTH",12);
    XSetWindowBackgroundPixmap(d2,w2,p_tile2);
    xsizehints.flags = (PBaseSize | PMinSize | PMaxSize);
    xsizehints.base_width  = 600;
    xsizehints.base_height = 500;
    xsizehints.min_width   = 600;
    xsizehints.min_height  = 500;
    xsizehints.max_width   = 600;
    xsizehints.max_height  = 500;
    XSetWMNormalHints(d2,w2,&xsizehints);

	strcpy(w2_name,"VS OTHELLO    From ");
	strcat(w2_name,getlogin());
	gethostname(stmp,128);
	if(strlen(stmp) > 0){
		strcat(w2_name,"@");
		strcat(w2_name,stmp);
		getdomainname(stmp,128);
		if(strlen(stmp) > 0){
			strcat(w2_name,".");
			strcat(w2_name,stmp);
		}
	}
    XStoreName(d2,w2,w2_name);

    XMapWindow(d2, w2);
    do { XNextEvent(d2, &e); } while(e.type!=Expose);
    XDefineCursor(d2,w2,XCreateFontCursor(d2,XC_watch));
    XFlush(d2);
}

void set_pixmap()
{
    static Pixmap kanji_kuro,  kanji_shiro,  bitmap;
    static unsigned long dsblue, lpink1,  tmp;

    p1 = XCreatePixmap(d1,w1,100,500,DefaultDepth(d1,0));
    p2 = XCreatePixmap(d2,w2,100,500,DefaultDepth(d2,0));
    nothing1 = XCreatePixmap(d1,w1,50,50,DefaultDepth(d1,0));
    blackon1 = XCreatePixmap(d1,w1,50,50,DefaultDepth(d1,0));
    whiteon1 = XCreatePixmap(d1,w1,50,50,DefaultDepth(d1,0));
    p1_b_to_w1 = XCreatePixmap(d1,w1,50,50,DefaultDepth(d1,0));
    p1_b_to_w2 = XCreatePixmap(d1,w1,50,50,DefaultDepth(d1,0));
    p1_b_to_w3 = XCreatePixmap(d1,w1,50,50,DefaultDepth(d1,0));
    p1_w_to_b1 = XCreatePixmap(d1,w1,50,50,DefaultDepth(d1,0));
    p1_w_to_b2 = XCreatePixmap(d1,w1,50,50,DefaultDepth(d1,0));
    p1_w_to_b3 = XCreatePixmap(d1,w1,50,50,DefaultDepth(d1,0));
    nothing2 = XCreatePixmap(d2,w2,50,50,DefaultDepth(d2,0));
    blackon2 = XCreatePixmap(d2,w2,50,50,DefaultDepth(d2,0));
    whiteon2 = XCreatePixmap(d2,w2,50,50,DefaultDepth(d2,0));
    p2_b_to_w1 = XCreatePixmap(d2,w2,50,50,DefaultDepth(d2,0));
    p2_b_to_w2 = XCreatePixmap(d2,w2,50,50,DefaultDepth(d2,0));
    p2_b_to_w3 = XCreatePixmap(d2,w2,50,50,DefaultDepth(d2,0));
    p2_w_to_b1 = XCreatePixmap(d2,w2,50,50,DefaultDepth(d2,0));
    p2_w_to_b2 = XCreatePixmap(d2,w2,50,50,DefaultDepth(d2,0));
    p2_w_to_b3 = XCreatePixmap(d2,w2,50,50,DefaultDepth(d2,0));
    p_koma_suu1 = XCreatePixmap(d1,w1,40,130,DefaultDepth(d1,0));
    p_koma_suu2 = XCreatePixmap(d2,w2,40,130,DefaultDepth(d2,0));

	p_last_b1 = XCreatePixmap(d1,w1,50,50,DefaultDepth(d1,0));
	p_last_w1 = XCreatePixmap(d1,w1,50,50,DefaultDepth(d1,0));
	p_last_b2 = XCreatePixmap(d2,w2,50,50,DefaultDepth(d2,0));
	p_last_w2 = XCreatePixmap(d2,w2,50,50,DefaultDepth(d2,0));

    XAllocNamedColor(d1,cmap1,"DeepSkyBlue",&col,&c0);
    XSetForeground(d1, gc1, col.pixel);
    XFillRectangle(d1,p1,gc1,0,0,100,500);
    XAllocNamedColor(d1,cmap1,"RoyalBlue",&col,&c0);
    XSetForeground(d1, gc1, col.pixel);
    XDrawLine(d1,p1,gc1,0,499,99,499);
    XDrawLine(d1,p1,gc1,0,498,99,498);
    XDrawLine(d1,p1,gc1,0,497,99,497);
    XDrawLine(d1,p1,gc1,99,0,99,499);
    XDrawLine(d1,p1,gc1,98,0,98,499);
    XDrawLine(d1,p1,gc1,97,0,97,499);

    XAllocNamedColor(d1,cmap1,"LightSkyBlue",&col,&c0);
    XSetForeground(d1, gc1, col.pixel);
    XDrawLine(d1,p1,gc1,0,0,0,499);
    XDrawLine(d1,p1,gc1,1,0,1,498);
    XDrawLine(d1,p1,gc1,2,0,2,497);
    XDrawLine(d1,p1,gc1,0,0,98,0);
    XDrawLine(d1,p1,gc1,0,1,97,1);
    XDrawLine(d1,p1,gc1,0,2,96,2);

    XDrawLine(d1,p1,gc1,0,150,98,150);
    XDrawLine(d1,p1,gc1,0,151,97,151);
    XDrawLine(d1,p1,gc1,0,152,96,152);
    XDrawLine(d1,p1,gc1,0,200,98,200);
    XDrawLine(d1,p1,gc1,0,201,97,201);
    XDrawLine(d1,p1,gc1,0,202,96,202);
    XDrawLine(d1,p1,gc1,0,350,98,350);
    XDrawLine(d1,p1,gc1,0,351,97,351);
    XDrawLine(d1,p1,gc1,0,352,96,352);
    XDrawLine(d1,p1,gc1,0,400,98,400);
    XDrawLine(d1,p1,gc1,0,401,97,401);
    XDrawLine(d1,p1,gc1,0,402,96,402);
    XDrawLine(d1,p1,gc1,0,450,98,450);
    XDrawLine(d1,p1,gc1,0,451,97,451);
    XDrawLine(d1,p1,gc1,0,452,96,452);
    XAllocNamedColor(d1,cmap1,"RoyalBlue",&col,&c0);
    XSetForeground(d1, gc1, col.pixel);
    XDrawLine(d1,p1,gc1,1,449,99,449);
    XDrawLine(d1,p1,gc1,2,448,99,448);
    XDrawLine(d1,p1,gc1,3,447,99,447);
    XDrawLine(d1,p1,gc1,1,399,99,399);
    XDrawLine(d1,p1,gc1,2,398,99,398);
    XDrawLine(d1,p1,gc1,3,397,99,397);
    XDrawLine(d1,p1,gc1,1,349,99,349);
    XDrawLine(d1,p1,gc1,2,348,99,348);
    XDrawLine(d1,p1,gc1,3,347,99,347);
    XDrawLine(d1,p1,gc1,1,199,99,199);
    XDrawLine(d1,p1,gc1,2,198,99,198);
    XDrawLine(d1,p1,gc1,3,197,99,197);
    XDrawLine(d1,p1,gc1,1,149,99,149);
    XDrawLine(d1,p1,gc1,2,148,99,148);
    XDrawLine(d1,p1,gc1,3,147,99,147);
    
    XAllocNamedColor(d2,cmap2,"LightPink1",&col,&c0);
    XSetForeground(d2, gc2, col.pixel);
    XFillRectangle(d2,p2,gc2,0,0,100,500);
    XAllocNamedColor(d2,cmap2,"LightPink3",&col,&c0);
    XSetForeground(d2, gc2, col.pixel);
    XDrawLine(d2,p2,gc2,0,499,99,499);
    XDrawLine(d2,p2,gc2,0,498,99,498);
    XDrawLine(d2,p2,gc2,0,497,99,497);
    XDrawLine(d2,p2,gc2,99,0,99,499);
    XDrawLine(d2,p2,gc2,98,0,98,499);
    XDrawLine(d2,p2,gc2,97,0,97,499);
    XAllocNamedColor(d2,cmap2,"pink",&col,&c0);
    XSetForeground(d2, gc2, col.pixel);
    XDrawLine(d2,p2,gc2,0,0,0,499);
    XDrawLine(d2,p2,gc2,1,0,1,498);
    XDrawLine(d2,p2,gc2,2,0,2,497);
    XDrawLine(d2,p2,gc2,0,0,98,0);
    XDrawLine(d2,p2,gc2,0,1,97,1);
    XDrawLine(d2,p2,gc2,0,2,96,2);
    XDrawLine(d2,p2,gc2,0,150,98,150);
    XDrawLine(d2,p2,gc2,0,151,97,151);
    XDrawLine(d2,p2,gc2,0,152,96,152);
    XDrawLine(d2,p2,gc2,0,200,98,200);
    XDrawLine(d2,p2,gc2,0,201,97,201);
    XDrawLine(d2,p2,gc2,0,202,96,202);
    XDrawLine(d2,p2,gc2,0,350,98,350);
    XDrawLine(d2,p2,gc2,0,351,97,351);
    XDrawLine(d2,p2,gc2,0,352,96,352);
    XDrawLine(d2,p2,gc2,0,400,98,400);
    XDrawLine(d2,p2,gc2,0,401,97,401);
    XDrawLine(d2,p2,gc2,0,402,96,402);
    XDrawLine(d2,p2,gc2,0,450,98,450);
    XDrawLine(d2,p2,gc2,0,451,97,451);
    XDrawLine(d2,p2,gc2,0,452,96,452);

    XAllocNamedColor(d2,cmap2,"LightPink3",&col,&c0);
    XSetForeground(d2, gc2, col.pixel);
    XDrawLine(d2,p2,gc2,1,449,99,449);
    XDrawLine(d2,p2,gc2,2,448,99,448);
    XDrawLine(d2,p2,gc2,3,447,99,447);
    XDrawLine(d2,p2,gc2,1,399,99,399);
    XDrawLine(d2,p2,gc2,2,398,99,398);
    XDrawLine(d2,p2,gc2,3,397,99,397);
    XDrawLine(d2,p2,gc2,1,349,99,349);
    XDrawLine(d2,p2,gc2,2,348,99,348);
    XDrawLine(d2,p2,gc2,3,347,99,347);
    XDrawLine(d2,p2,gc2,1,199,99,199);
    XDrawLine(d2,p2,gc2,2,198,99,198);
    XDrawLine(d2,p2,gc2,3,197,99,197);
    XDrawLine(d2,p2,gc2,1,149,99,149);
    XDrawLine(d2,p2,gc2,2,148,99,148);
    XDrawLine(d2,p2,gc2,3,147,99,147);


    XSetFont(d1,gc1,XLoadFont(d1, F20));
    XAllocNamedColor(d1,cmap1,"RoyalBlue",&col,&c0);
    XSetForeground(d1, gc1, col.pixel);
    XDrawString(d1,p1,gc1,13,438,"Give up",7);
    XSetForeground(d1, gc1, black1);
    XDrawString(d1,p1,gc1,10,435,"Give up",7);

    XSetFont(d1,gc1,XLoadFont(d1, F24));
    XAllocNamedColor(d1,cmap1,"RoyalBlue",&col,&c0);
    XSetForeground(d1, gc1, col.pixel);
    XDrawString(d1,p1,gc1,20,388,"PASS",4);
    XDrawString(d1,p1,gc1,13,488,"CLOSE",5);
    XSetForeground(d1, gc1, black1);
    XDrawString(d1,p1,gc1,17,385,"PASS",4);
    XDrawString(d1,p1,gc1,10,485,"CLOSE",5);

    XSetFont(d2,gc2,XLoadFont(d2, F20));
    XAllocNamedColor(d2,cmap2,"LightPink3",&col,&c0);
    XSetForeground(d2, gc2, col.pixel);
    XDrawString(d2,p2,gc2,13,438,"Give up",7);
    XSetForeground(d2, gc2, black2);
    XDrawString(d2,p2,gc2,10,435,"Give up",7);
    XSetFont(d2,gc2,XLoadFont(d2, F24));
    XAllocNamedColor(d2,cmap2,"LightPink3",&col,&c0);
    XSetForeground(d2, gc2, col.pixel);
    XDrawString(d2,p2,gc2,20,388,"PASS",4);
    XDrawString(d2,p2,gc2,13,488,"CLOSE",5);
    XSetForeground(d2, gc2, black2);
    XDrawString(d2,p2,gc2,17,385,"PASS",4);
    XDrawString(d2,p2,gc2,10,485,"CLOSE",5);


    XAllocNamedColor(d1,cmap1,"RoyalBlue",&col,&c0);
    tmp = col.pixel;
    XAllocNamedColor(d1,cmap1,"DeepSkyBlue",&col,&c0);
    dsblue = col.pixel;
    kanji_kuro = XCreatePixmapFromBitmapData(d1,p1,kuro_bits,40,40,
                              tmp, dsblue, DefaultDepth(d1,0));
    bitmap = XCreateBitmapFromData(d1, kanji_kuro, kuro_bits,40,40);
    XSetFillStyle(d1,gc1,FillStippled);
    XSetStipple(d1, gc1, bitmap);
    XSetTSOrigin(d1,gc1,37,37);
    XFillRectangle(d1,kanji_kuro,gc1,0,0,40,40);
    XSetFillStyle(d1,gc1,FillSolid);
    XSetTSOrigin(d1,gc1,0,0);
    XCopyArea(d1, kanji_kuro, p1, gc1, 0, 0, 40, 40, 5, 225);
    kanji_shiro = XCreatePixmapFromBitmapData(d1,p1,shiro_bits,40,40,
                              tmp, dsblue, DefaultDepth(d1,0));
    bitmap = XCreateBitmapFromData(d1, kanji_shiro, shiro_bits,40,40);
    XSetFillStyle(d1,gc1,FillStippled);
    XSetStipple(d1, gc1, bitmap);
    XSetTSOrigin(d1,gc1,37,37);
    XFillRectangle(d1,kanji_shiro,gc1,0,0,40,40);
    XSetFillStyle(d1,gc1,FillSolid);
    XSetTSOrigin(d1,gc1,0,0);
    XCopyArea(d1, kanji_shiro, p1, gc1, 0, 0, 40, 40, 5, 290);


    XAllocNamedColor(d2,cmap2,"LightPink4",&col,&c0);
    tmp = col.pixel;
    XAllocNamedColor(d2,cmap2,"LightPink1",&col,&c0);
    lpink1 = col.pixel;
    kanji_kuro = XCreatePixmapFromBitmapData(d2,p2,kuro_bits,40,40,
                              tmp, lpink1, DefaultDepth(d2,0));
    bitmap = XCreateBitmapFromData(d2, kanji_kuro, kuro_bits,40,40);
    XSetFillStyle(d2,gc2,FillStippled);
    XSetStipple(d2, gc2, bitmap);
    XSetTSOrigin(d2,gc2,37,37);
    XFillRectangle(d2,kanji_kuro,gc2,0,0,40,40);
    XSetFillStyle(d2,gc2,FillSolid);
    XSetTSOrigin(d2,gc2,0,0);
    XCopyArea(d2, kanji_kuro, p2, gc2, 0, 0, 40, 40, 5, 225);
    kanji_shiro = XCreatePixmapFromBitmapData(d2,p2,shiro_bits,40,40,
                              tmp, lpink1, DefaultDepth(d2,0));
    bitmap = XCreateBitmapFromData(d2, kanji_shiro, shiro_bits,40,40);
    XSetFillStyle(d2,gc2,FillStippled);
    XSetStipple(d2, gc2, bitmap);
    XSetTSOrigin(d2,gc2,37,37);
    XFillRectangle(d2,kanji_shiro,gc2,0,0,40,40);
    XSetFillStyle(d2,gc2,FillSolid);
    XSetTSOrigin(d2,gc2,0,0);
    XCopyArea(d2, kanji_shiro, p2, gc2, 0, 0, 40, 40, 5, 290);


    col.blue = col.red = 0L;
    col.green = (long)(200 * 65535L / 255.);
    XAllocColor(d1, cmap1, &col);
    XSetForeground(d1, gc1, col.pixel);
    XFillRectangle(d1,nothing1,gc1,0,0,50,50);
    col.green = (long)(100 * 65535L / 255.);
    XAllocColor(d1, cmap1, &col);
    XSetForeground(d1, gc1, col.pixel);
    XDrawLine(d1,nothing1,gc1,0,47,50,47);
    XDrawLine(d1,nothing1,gc1,0,48,50,48);
    XDrawLine(d1,nothing1,gc1,0,49,50,49);
    XDrawLine(d1,nothing1,gc1,47,0,47,50);
    XDrawLine(d1,nothing1,gc1,48,0,48,50);
    XDrawLine(d1,nothing1,gc1,49,0,49,50);
    col.green = (long)(230 * 65535L / 255.);
    XAllocColor(d1, cmap1, &col);
    XSetForeground(d1, gc1, col.pixel);
    XDrawLine(d1,nothing1,gc1,0,0,0,49);
    XDrawLine(d1,nothing1,gc1,1,0,1,48);
    XDrawLine(d1,nothing1,gc1,2,0,2,47);
    XDrawLine(d1,nothing1,gc1,0,0,49,0);
    XDrawLine(d1,nothing1,gc1,0,1,48,1);
    XDrawLine(d1,nothing1,gc1,0,2,47,2);
    XCopyArea(d1,nothing1,blackon1,gc1,0,0,50,50,0,0);
    XCopyArea(d1,nothing1,whiteon1,gc1,0,0,50,50,0,0);
    XSetForeground(d1, gc1, white1);
    XFillArc(d1,whiteon1,gc1,5,5,40,40,0,23040);
    XSetForeground(d1, gc1, black1);
    XDrawArc(d1,whiteon1,gc1,5,5,40,40,0,23040);
    XFillArc(d1,blackon1,gc1,5,5,40,40,0,23040);

    col.blue = col.red = 0L;
    col.green = (long)(200 * 65535L / 255.);
    XAllocColor(d2, cmap2, &col);
    XSetForeground(d2, gc2, col.pixel);
    XFillRectangle(d2,nothing2,gc2,0,0,50,50);
    col.green = (long)(100 * 65535L / 255.);
    XAllocColor(d2, cmap2, &col);
    XSetForeground(d2, gc2, col.pixel);
    XDrawLine(d2,nothing2,gc2,0,47,50,47);
    XDrawLine(d2,nothing2,gc2,0,48,50,48);
    XDrawLine(d2,nothing2,gc2,0,49,50,49);
    XDrawLine(d2,nothing2,gc2,47,0,47,50);
    XDrawLine(d2,nothing2,gc2,48,0,48,50);
    XDrawLine(d2,nothing2,gc2,49,0,49,50);
    col.green = (long)(230 * 65535L / 255.);
    XAllocColor(d2, cmap2, &col);
    XSetForeground(d2, gc2, col.pixel);
    XDrawLine(d2,nothing2,gc2,0,0,0,49);
    XDrawLine(d2,nothing2,gc2,1,0,1,48);
    XDrawLine(d2,nothing2,gc2,2,0,2,47);
    XDrawLine(d2,nothing2,gc2,0,0,49,0);
    XDrawLine(d2,nothing2,gc2,0,1,48,1);
    XDrawLine(d2,nothing2,gc2,0,2,47,2);
    XCopyArea(d2,nothing2,blackon2,gc2,0,0,50,50,0,0);
    XCopyArea(d2,nothing2,whiteon2,gc2,0,0,50,50,0,0);
    XSetForeground(d2, gc2, white2);
    XFillArc(d2,whiteon2,gc2,5,5,40,40,0,23040);
    XSetForeground(d2, gc2, black2);
    XDrawArc(d2,whiteon2,gc2,5,5,40,40,0,23040);
    XFillArc(d2,blackon2,gc2,5,5,40,40,0,23040);

    uragaeshi();
    XSync(d1,1);
    XSync(d2,1);
}

int uragaeshi()
{
/*  p1   white to black 45' */
    XCopyArea(d1,nothing1,p1_w_to_b1,gc1,0,0,50,50,0,0);
    XSetForeground(d1,  gc1,  black1);
    XFillArc(d1, p1_w_to_b1, gc1, 5, 5, 28, 40, 0, 23040);
    XFillRectangle(d1, p1_w_to_b1, gc1, 19, 5, 6, 41);
    XSetForeground(d1,  gc1,  white1);
    XFillArc(d1, p1_w_to_b1, gc1, 8, 5, 28, 40, 0, 23040);
    XFillRectangle(d1, p1_w_to_b1, gc1, 22, 4, 3, 39);
    XFillArc(d1, p1_w_to_b1, gc1, 11, 5, 28, 40, 0, 23040);
    XSetForeground(d1,  gc1,  black1);
    XDrawArc(d1, p1_w_to_b1, gc1, 11, 5, 28, 40, 0, 23040);

/*  p1   white to black 90' */
    XCopyArea(d1,nothing1,p1_w_to_b2,gc1,0,0,50,50,0,0);
    XDrawRectangle(d1, p1_w_to_b2, gc1, 21, 5, 9, 41);
    XFillRectangle(d1, p1_w_to_b2, gc1, 22, 6, 3, 39);
    XSetForeground(d1,  gc1,  white1);
    XFillRectangle(d1, p1_w_to_b2, gc1, 26, 6, 3, 39);

/*  p1   white to black 135'    */
    XCopyArea(d1,nothing1,p1_w_to_b3,gc1,0,0,50,50,0,0);
    XFillArc(d1, p1_w_to_b3, gc1, 17,5,28,40,0,23040);
    XSetForeground(d1,  gc1,  black1);
    XDrawArc(d1, p1_w_to_b3, gc1, 17,5,28,40,0,23040);
    XFillArc(d1, p1_w_to_b3, gc1, 14,5,28,40,0,23040);
    XFillArc(d1, p1_w_to_b3, gc1, 11,5,28,40,0,23040);
    XDrawLine(d1, p1_w_to_b3, gc1, 25,5,31,5);
    XDrawLine(d1, p1_w_to_b3, gc1, 25,45,31,45);
    XFillRectangle(d1, p1_w_to_b3, gc1, 25,5,3,40);


/*  p1   black to white 45' */
    XCopyArea(d1,nothing1,p1_b_to_w1,gc1,0,0,50,50,0,0);
    XSetForeground(d1,  gc1,  white1);
    XFillArc(d1,p1_b_to_w1,gc1,5,5,28,40,0,23040);
    XSetForeground(d1,gc1,black1);
    XDrawArc(d1,p1_b_to_w1,gc1,5,5,28,40,0,23040);
    XFillArc(d1,p1_b_to_w1,gc1,9,5,28,40,0,23040);
    XFillArc(d1,p1_b_to_w1,gc1,11,5,28,40,0,23040);
    XFillRectangle(d1,p1_b_to_w1,gc1,22,5,6,41);
    XDrawArc(d1,p1_b_to_w1,gc1,11,5,28,40,0,23040);

/*  p1   black to white 90' */
    XCopyArea(d1,nothing1,p1_b_to_w2,gc1,0,0,50,50,0,0);
    XDrawRectangle(d1,p1_b_to_w2,gc1,21,5,9,41);
    XFillRectangle(d1,p1_b_to_w2,gc1,26,6,3,39);
    XSetForeground(d1,gc1,white1);
    XFillRectangle(d1,p1_b_to_w2,gc1,22,6,3,39);

/*  p1   black to white 135'    */
    XCopyArea(d1,nothing1,p1_b_to_w3,gc1,0,0,50,50,0,0);
    XSetForeground(d1,gc1,black1);
    XFillArc(d1,p1_b_to_w3,gc1,17,5,28,40,0,23040);
    XFillRectangle(d1,p1_b_to_w3,gc1,25,5,3,40);
    XSetForeground(d1,gc1,white1);
    XFillArc(d1,p1_b_to_w3,gc1,14,5,28,40,0,23040);
    XFillArc(d1,p1_b_to_w3,gc1,11,5,28,40,0,23040);
    XSetForeground(d1,gc1,black1);
    XDrawArc(d1,p1_b_to_w3,gc1,11,5,28,40,0,23040);

/*  p2   white to black 45' */
    XCopyArea(d2,nothing2,p2_w_to_b1,gc2,0,0,50,50,0,0);
    XSetForeground(d2,  gc2,  black2);
    XFillArc(d2, p2_w_to_b1, gc2, 5, 5, 28, 40, 0, 23040);
    XFillRectangle(d2, p2_w_to_b1, gc2, 19, 5, 6, 41);
    XSetForeground(d2,  gc2,  white2);
    XFillArc(d2, p2_w_to_b1, gc2, 8, 5, 28, 40, 0, 23040);
    XFillRectangle(d2, p2_w_to_b1, gc2, 22, 4, 3, 39);
    XFillArc(d2, p2_w_to_b1, gc2, 11, 5, 28, 40, 0, 23040);
    XSetForeground(d2,  gc2,  black2);
    XDrawArc(d2, p2_w_to_b1, gc2, 11, 5, 28, 40, 0, 23040);

/*  p2   white to black 90' */
    XCopyArea(d2,nothing2,p2_w_to_b2,gc2,0,0,50,50,0,0);
    XDrawRectangle(d2, p2_w_to_b2, gc2, 21, 5, 9, 41);
    XFillRectangle(d2, p2_w_to_b2, gc2, 22, 6, 3, 39);
    XSetForeground(d2,  gc2,  white2);
    XFillRectangle(d2, p2_w_to_b2, gc2, 26, 6, 3, 39);

/*  p2   white to black 135'    */
    XCopyArea(d2,nothing2,p2_w_to_b3,gc2,0,0,50,50,0,0);
    XFillArc(d2, p2_w_to_b3, gc2, 17,5,28,40,0,23040);
    XSetForeground(d2,  gc2,  black2);
    XDrawArc(d2, p2_w_to_b3, gc2, 17,5,28,40,0,23040);
    XFillArc(d2, p2_w_to_b3, gc2, 14,5,28,40,0,23040);
    XFillArc(d2, p2_w_to_b3, gc2, 11,5,28,40,0,23040);
    XDrawLine(d2, p2_w_to_b3, gc2, 25,5,31,5);
    XDrawLine(d2, p2_w_to_b3, gc2, 25,45,31,45);
    XFillRectangle(d2, p2_w_to_b3, gc2, 25,5,3,40);


/*  p2   black to white 45' */
    XCopyArea(d2,nothing2,p2_b_to_w1,gc2,0,0,50,50,0,0);
    XSetForeground(d2,  gc2,  white2);
    XFillArc(d2,p2_b_to_w1,gc2,5,5,28,40,0,23040);
    XSetForeground(d2,gc2,black2);
    XDrawArc(d2,p2_b_to_w1,gc2,5,5,28,40,0,23040);
    XFillArc(d2,p2_b_to_w1,gc2,9,5,28,40,0,23040);
    XFillArc(d2,p2_b_to_w1,gc2,11,5,28,40,0,23040);
    XFillRectangle(d2,p2_b_to_w1,gc2,22,5,6,41);
    XDrawArc(d2,p2_b_to_w1,gc2,11,5,28,40,0,23040);

/*  p2   black to white 90' */
    XCopyArea(d2,nothing2,p2_b_to_w2,gc2,0,0,50,50,0,0);
    XDrawRectangle(d2,p2_b_to_w2,gc2,21,5,9,41);
    XFillRectangle(d2,p2_b_to_w2,gc2,26,6,3,39);
    XSetForeground(d2,gc2,white2);
    XFillRectangle(d2,p2_b_to_w2,gc2,22,6,3,39);

/*  p2   black to white 135'    */
    XCopyArea(d2,nothing2,p2_b_to_w3,gc2,0,0,50,50,0,0);
    XSetForeground(d2,gc2,black2);
    XFillArc(d2,p2_b_to_w3,gc2,17,5,28,40,0,23040);
    XFillRectangle(d2,p2_b_to_w3,gc2,25,5,3,40);
    XSetForeground(d2,gc2,white2);
    XFillArc(d2,p2_b_to_w3,gc2,14,5,28,40,0,23040);
    XFillArc(d2,p2_b_to_w3,gc2,11,5,28,40,0,23040);
    XSetForeground(d2,gc2,black2);
    XDrawArc(d2,p2_b_to_w3,gc2,11,5,28,40,0,23040);

/*  and so on	*/
	XCopyArea(d1,blackon1,p_last_b1,gc1,0,0,50,50,0,0);
	XCopyArea(d1,whiteon1,p_last_w1,gc1,0,0,50,50,0,0);
    XAllocNamedColor(d1,cmap1,"Yellow",&col,&c0);
    XSetForeground(d1, gc1, col.pixel);
    XDrawLine(d1, p_last_b1, gc1, 0,0,0,9);
    XDrawLine(d1, p_last_b1, gc1, 1,0,1,9);
    XDrawLine(d1, p_last_b1, gc1, 2,0,2,9);
    XDrawLine(d1, p_last_b1, gc1, 47,0,47,9);
    XDrawLine(d1, p_last_b1, gc1, 48,0,48,9);
    XDrawLine(d1, p_last_b1, gc1, 49,0,49,9);
    XDrawLine(d1, p_last_b1, gc1, 0,40,0,49);
    XDrawLine(d1, p_last_b1, gc1, 1,40,1,49);
    XDrawLine(d1, p_last_b1, gc1, 2,40,2,49);
    XDrawLine(d1, p_last_b1, gc1, 47,40,47,49);
    XDrawLine(d1, p_last_b1, gc1, 48,40,48,49);
    XDrawLine(d1, p_last_b1, gc1, 49,40,49,49);
    XDrawLine(d1, p_last_b1, gc1, 0,0,9,0);
    XDrawLine(d1, p_last_b1, gc1, 0,1,9,1);
    XDrawLine(d1, p_last_b1, gc1, 0,2,9,2);
    XDrawLine(d1, p_last_b1, gc1, 0,47,9,47);
    XDrawLine(d1, p_last_b1, gc1, 0,48,9,48);
    XDrawLine(d1, p_last_b1, gc1, 0,49,9,49);
    XDrawLine(d1, p_last_b1, gc1, 40,0,49,0);
    XDrawLine(d1, p_last_b1, gc1, 40,1,49,1);
    XDrawLine(d1, p_last_b1, gc1, 40,2,49,2);
    XDrawLine(d1, p_last_b1, gc1, 40,47,49,47);
    XDrawLine(d1, p_last_b1, gc1, 40,48,49,48);
    XDrawLine(d1, p_last_b1, gc1, 40,49,49,49);

    XDrawLine(d1, p_last_w1, gc1, 0,0,0,9);
    XDrawLine(d1, p_last_w1, gc1, 1,0,1,9);
    XDrawLine(d1, p_last_w1, gc1, 2,0,2,9);
    XDrawLine(d1, p_last_w1, gc1, 47,0,47,9);
    XDrawLine(d1, p_last_w1, gc1, 48,0,48,9);
    XDrawLine(d1, p_last_w1, gc1, 49,0,49,9);
    XDrawLine(d1, p_last_w1, gc1, 0,40,0,49);
    XDrawLine(d1, p_last_w1, gc1, 1,40,1,49);
    XDrawLine(d1, p_last_w1, gc1, 2,40,2,49);
    XDrawLine(d1, p_last_w1, gc1, 47,40,47,49);
    XDrawLine(d1, p_last_w1, gc1, 48,40,48,49);
    XDrawLine(d1, p_last_w1, gc1, 49,40,49,49);
    XDrawLine(d1, p_last_w1, gc1, 0,0,9,0);
    XDrawLine(d1, p_last_w1, gc1, 0,1,9,1);
    XDrawLine(d1, p_last_w1, gc1, 0,2,9,2);
    XDrawLine(d1, p_last_w1, gc1, 0,47,9,47);
    XDrawLine(d1, p_last_w1, gc1, 0,48,9,48);
    XDrawLine(d1, p_last_w1, gc1, 0,49,9,49);
    XDrawLine(d1, p_last_w1, gc1, 40,0,49,0);
    XDrawLine(d1, p_last_w1, gc1, 40,1,49,1);
    XDrawLine(d1, p_last_w1, gc1, 40,2,49,2);
    XDrawLine(d1, p_last_w1, gc1, 40,47,49,47);
    XDrawLine(d1, p_last_w1, gc1, 40,48,49,48);
    XDrawLine(d1, p_last_w1, gc1, 40,49,49,49);

	XCopyArea(d2,blackon2,p_last_b2,gc2,0,0,50,50,0,0);
	XCopyArea(d2,whiteon2,p_last_w2,gc2,0,0,50,50,0,0);
    XAllocNamedColor(d2,cmap2,"Yellow",&col,&c0);
    XSetForeground(d2, gc2, col.pixel);
    XDrawLine(d2, p_last_b2, gc2, 0,0,0,9);
    XDrawLine(d2, p_last_b2, gc2, 1,0,1,9);
    XDrawLine(d2, p_last_b2, gc2, 2,0,2,9);
    XDrawLine(d2, p_last_b2, gc2, 47,0,47,9);
    XDrawLine(d2, p_last_b2, gc2, 48,0,48,9);
    XDrawLine(d2, p_last_b2, gc2, 49,0,49,9);
    XDrawLine(d2, p_last_b2, gc2, 0,40,0,49);
    XDrawLine(d2, p_last_b2, gc2, 1,40,1,49);
    XDrawLine(d2, p_last_b2, gc2, 2,40,2,49);
    XDrawLine(d2, p_last_b2, gc2, 47,40,47,49);
    XDrawLine(d2, p_last_b2, gc2, 48,40,48,49);
    XDrawLine(d2, p_last_b2, gc2, 49,40,49,49);
    XDrawLine(d2, p_last_b2, gc2, 0,0,9,0);
    XDrawLine(d2, p_last_b2, gc2, 0,1,9,1);
    XDrawLine(d2, p_last_b2, gc2, 0,2,9,2);
    XDrawLine(d2, p_last_b2, gc2, 0,47,9,47);
    XDrawLine(d2, p_last_b2, gc2, 0,48,9,48);
    XDrawLine(d2, p_last_b2, gc2, 0,49,9,49);
    XDrawLine(d2, p_last_b2, gc2, 40,0,49,0);
    XDrawLine(d2, p_last_b2, gc2, 40,1,49,1);
    XDrawLine(d2, p_last_b2, gc2, 40,2,49,2);
    XDrawLine(d2, p_last_b2, gc2, 40,47,49,47);
    XDrawLine(d2, p_last_b2, gc2, 40,48,49,48);
    XDrawLine(d2, p_last_b2, gc2, 40,49,49,49);

    XDrawLine(d2, p_last_w2, gc2, 0,0,0,9);
    XDrawLine(d2, p_last_w2, gc2, 1,0,1,9);
    XDrawLine(d2, p_last_w2, gc2, 2,0,2,9);
    XDrawLine(d2, p_last_w2, gc2, 47,0,47,9);
    XDrawLine(d2, p_last_w2, gc2, 48,0,48,9);
    XDrawLine(d2, p_last_w2, gc2, 49,0,49,9);
    XDrawLine(d2, p_last_w2, gc2, 0,40,0,49);
    XDrawLine(d2, p_last_w2, gc2, 1,40,1,49);
    XDrawLine(d2, p_last_w2, gc2, 2,40,2,49);
    XDrawLine(d2, p_last_w2, gc2, 47,40,47,49);
    XDrawLine(d2, p_last_w2, gc2, 48,40,48,49);
    XDrawLine(d2, p_last_w2, gc2, 49,40,49,49);
    XDrawLine(d2, p_last_w2, gc2, 0,0,9,0);
    XDrawLine(d2, p_last_w2, gc2, 0,1,9,1);
    XDrawLine(d2, p_last_w2, gc2, 0,2,9,2);
    XDrawLine(d2, p_last_w2, gc2, 0,47,9,47);
    XDrawLine(d2, p_last_w2, gc2, 0,48,9,48);
    XDrawLine(d2, p_last_w2, gc2, 0,49,9,49);
    XDrawLine(d2, p_last_w2, gc2, 40,0,49,0);
    XDrawLine(d2, p_last_w2, gc2, 40,1,49,1);
    XDrawLine(d2, p_last_w2, gc2, 40,2,49,2);
    XDrawLine(d2, p_last_w2, gc2, 40,47,49,47);
    XDrawLine(d2, p_last_w2, gc2, 40,48,49,48);
    XDrawLine(d2, p_last_w2, gc2, 40,49,49,49);

}
/*EOF*/
