#include "vs_othello.h"
#include "bitmap/stipple.xbm"

void result(id,kurokoma,shirokoma)
int id,  kurokoma,  shirokoma;
{
    static Pixmap bitmap1,  bitmap2;

    bitmap1 = XCreateBitmapFromData(d1,w1,stipple_bits,2,2);
    bitmap2 = XCreateBitmapFromData(d2,w2,stipple_bits,2,2);

	if(id == 2){
		kurokoma  = 0;
		shirokoma = 1;
		id = 0;
	}
	else if(id == 3){
		kurokoma  = 1;
		shirokoma = 0;
		id = 0;
	}
	else if(id == 4){
		kurokoma  = 0;
		shirokoma = 1;
		id = 1;
	}
	else if(id == 5){
		kurokoma  = 1;
		shirokoma = 0;
		id = 1;
	}
    XSetFillStyle(d1,gc1,FillStippled);
    XSetStipple(d1,gc1,bitmap1);
    XAllocNamedColor(d1,cmap1,"blue",&col,&c0);
    XSetForeground(d1, gc1, col.pixel);
    XFillRectangle(d1,w1,gc1,50,200,400,100);
    XAllocNamedColor(d1,cmap1,"red",&col,&c0);
    XSetForeground(d1, gc1, col.pixel);
    XSetFont(d1,gc1,XLoadFont(d1, F60));

	if(id == 0){
	    if(kurokoma > shirokoma)
	        XDrawString(d1,w1,gc1,75,280,"You win.",8);
	    else if(kurokoma < shirokoma)
	        XDrawString(d1,w1,gc1,60,280,"You lose.",9);
	    else
	        XDrawString(d1,w1,gc1,125,280,"Draw.",5);
	}
	else{
	    if(kurokoma > shirokoma)
	        XDrawString(d1,w1,gc1,60,280,"You lose.",9);
	    else if(kurokoma < shirokoma)
	        XDrawString(d1,w1,gc1,75,280,"You win.",8);
	    else
	        XDrawString(d1,w1,gc1,125,280,"Draw.",5);
	}


    XSetFillStyle(d2,gc2,FillStippled);
    XSetStipple(d2,gc2,bitmap2);
    XAllocNamedColor(d2,cmap2,"red",&col,&c0);
    XSetForeground(d2, gc2, col.pixel);
    XFillRectangle(d2,w2,gc2,50,200,400,100);
    XAllocNamedColor(d2,cmap2,"blue",&col,&c0);
    XSetForeground(d2, gc2, col.pixel);
    XSetFont(d2,gc2,XLoadFont(d2, F60));
	if(id == 0){
	    if(kurokoma > shirokoma)
	        XDrawString(d2,w2,gc2,60,280,"You lose.",9);
	    else if(kurokoma < shirokoma)
	        XDrawString(d2,w2,gc2,75,280,"You win.",8);
	    else
	        XDrawString(d2,w2,gc2,125,280,"Draw.",5);
	}
	else{
	    if(kurokoma > shirokoma)
	        XDrawString(d2,w2,gc2,75,280,"You win.",8);
	    else if(kurokoma < shirokoma)
	        XDrawString(d2,w2,gc2,60,280,"You lose.",9);
	    else
	        XDrawString(d2,w2,gc2,125,280,"Draw.",5);
	}

    XSetFillStyle(d1, gc1, FillSolid);
    XSetFillStyle(d2, gc2, FillSolid);
    XFlush(d1);
    XFlush(d2);
}
