#include "vs_othello.h"

#define WAIT     300000
#define REV_WAIT 80000

void put(x, y, pid, id)
int x,y,pid,id;
{
    if(pid == 1){
        if(id == 1){
            XCopyArea(d1,p1_w_to_b1,w1,gc1,0,0,50,50,50+50*x,50+50*y);
            XCopyArea(d2,p2_w_to_b1,w2,gc2,0,0,50,50,50+50*x,50+50*y);
            XSync(d1,0);
            XSync(d2,0);
            usleep(REV_WAIT);
            XCopyArea(d1,p1_w_to_b2,w1,gc1,0,0,50,50,50+50*x,50+50*y);
            XCopyArea(d2,p2_w_to_b2,w2,gc2,0,0,50,50,50+50*x,50+50*y);
            XSync(d1,0);
            XSync(d2,0);
            usleep(REV_WAIT);
            XCopyArea(d1,p1_w_to_b3,w1,gc1,0,0,50,50,50+50*x,50+50*y);
            XCopyArea(d2,p2_w_to_b3,w2,gc2,0,0,50,50,50+50*x,50+50*y);
            XSync(d1,0);
            XSync(d2,0);
            usleep(REV_WAIT);
            shiro_koma--;
        	XCopyArea(d1,blackon1,w1,gc1,0,0,50,50,50+50*x,50+50*y);
	        XCopyArea(d2,blackon2,w2,gc2,0,0,50,50,50+50*x,50+50*y);
        }
		else{
        	XCopyArea(d1,p_last_b1,w1,gc1,0,0,50,50,50+50*x,50+50*y);
	        XCopyArea(d2,p_last_b2,w2,gc2,0,0,50,50,50+50*x,50+50*y);
			if( (last_x >= 0) && (last_y >= 0) ){
	        	XCopyArea(d1,whiteon1,w1,gc1,0,0,50,50,50+50*last_x,50+50*last_y);
		        XCopyArea(d2,whiteon2,w2,gc2,0,0,50,50,50+50*last_x,50+50*last_y);
			}
			last_x = x;
			last_y = y;
		}
        kuro_koma++;
        put_koma_suu();
        XSync(d1,0);
        XSync(d2,0);
    }
    else if(pid == 2){
        if(id == 1){
            XCopyArea(d1,p1_b_to_w1,w1,gc1,0,0,50,50,50+50*x,50+50*y);
            XCopyArea(d2,p2_b_to_w1,w2,gc2,0,0,50,50,50+50*x,50+50*y);
            XSync(d1,0);
            XSync(d2,0);
            usleep(REV_WAIT);
            XCopyArea(d1,p1_b_to_w2,w1,gc1,0,0,50,50,50+50*x,50+50*y);
            XCopyArea(d2,p2_b_to_w2,w2,gc2,0,0,50,50,50+50*x,50+50*y);
            XSync(d1,0);
            XSync(d2,0);
            usleep(REV_WAIT);
            XCopyArea(d1,p1_b_to_w3,w1,gc1,0,0,50,50,50+50*x,50+50*y);
            XCopyArea(d2,p2_b_to_w3,w2,gc2,0,0,50,50,50+50*x,50+50*y);
            XSync(d1,0);
            XSync(d2,0);
            usleep(REV_WAIT);
            kuro_koma--;
        	XCopyArea(d1,whiteon1,w1,gc1,0,0,50,50,50+50*x,50+50*y);
        	XCopyArea(d2,whiteon2,w2,gc2,0,0,50,50,50+50*x,50+50*y);
        }
		else{
        	XCopyArea(d1,p_last_w1,w1,gc1,0,0,50,50,50+50*x,50+50*y);
	        XCopyArea(d2,p_last_w2,w2,gc2,0,0,50,50,50+50*x,50+50*y);
			if( (last_x >= 0) && (last_y >= 0) ){
	        	XCopyArea(d1,blackon1,w1,gc1,0,0,50,50,50+50*last_x,50+50*last_y);
		        XCopyArea(d2,blackon2,w2,gc2,0,0,50,50,50+50*last_x,50+50*last_y);
			}
			last_x = x;
			last_y = y;
		}
        shiro_koma++;
        put_koma_suu();
        XSync(d1,0);
        XSync(d2,0);
    }
    else return;
    usleep(WAIT);
}

void reverse(a,x,y,pid)
int a[8][8],x,y,pid;
{
    static int i,j;
    static int eid;

    eid = (pid == 1) ? 2 : 1;

    a[x][y] = pid;
    put(x,y,pid,0);

/*  ΢֤    */
    if(y > 0){
        i = 1;
        if(a[x][y-i] == eid){
            for(i=2;y>=i;i++){
                if(a[x][y-i] == pid){
                    for(j=1;j<i;j++){
                        a[x][y-j] = pid;
                        put(x,y-j,pid,1);
                    }
                    break;
                }
                else if(a[x][y-i] == 0)
                    break;
            }
        }
    }

/*  ΢֤  */
    if( (x > 0)&&(y > 0) ){
        i = 1;
        if(a[x-i][y-i] == eid){
            for(i=2;(x>=i)&&(y>=i);i++){
                if(a[x-i][y-i] == pid){
                    for(j=1;j<i;j++){
                        a[x-j][y-j] = pid;
                        put(x-j,y-j,pid,1);
                    }
                    break;
                }
                else if(a[x-i][y-i] == 0)
                    break;
            }
        }
    }

/*  ΢֤    */
    if(x > 0){
        i = 1;
        if(a[x-i][y] == eid){
            for(i=2;x>=i;i++){
                if(a[x-i][y] == pid){
                    for(j=1;j<i;j++){
                        a[x-j][y] = pid;
                        put(x-j,y,pid,1);
                    }
                    break;
                }
                else if(a[x-i][y] == 0)
                    break;
            }
        }
    }

/*  ΢֤  */
    if( (x > 0)&&(y < 7) ){
        i = 1;
        if(a[x-i][y+i] == eid){
            for(i=2;(x>=i)&&(y+i<8);i++){
                if(a[x-i][y+i] == pid){
                    for(j=1;j<i;j++){
                        a[x-j][y+j] = pid;
                        put(x-j,y+j,pid,1);
                    }
                    break;
                }
                else if(a[x-i][y+i] == 0)
                    break;
            }
        }
    }

/*  ΢֤    */
    if(y < 7){
        i = 1;
        if(a[x][y+i] == eid){
            for(i=2;y+i<8;i++){
                if(a[x][y+i] == pid){
                    for(j=1;j<i;j++){
                        a[x][y+j] = pid;
                        put(x,y+j,pid,1);
                    }
                    break;
                }
                else if(a[x][y+i] == 0)
                    break;
            }
        }
    }

/*  ΢֤  */
    if( (x < 7)&&(y < 7) ){
        i = 1;
        if(a[x+i][y+i] == eid){
            for(i=2;(x+i<8)&&(y+i<8);i++){
                if(a[x+i][y+i] == pid){
                    for(j=1;j<i;j++){
                        a[x+j][y+j] = pid;
                        put(x+j,y+j,pid,1);
                    }
                    break;
                }
                else if(a[x+i][y+i] == 0)
                    break;
            }
        }
    }

/*  ΢֤    */
    if(x < 7){
        i = 1;
        if(a[x+i][y] == eid){
            for(i=2;x+i<8;i++){
                if(a[x+i][y] == pid){
                    for(j=1;j<i;j++){
                        a[x+j][y] = pid;
                        put(x+j,y,pid,1);
                    }
                    break;
                }
                else if(a[x+i][y] == 0)
                    break;
            }
        }
    }

/*  ΢֤  */
    if( (x < 7)&&(y > 0) ){
        i = 1;
        if(a[x+i][y-i] == eid){
            for(i=2;(x+i<8)&&(y>=i);i++){
                if(a[x+i][y-i] == pid){
                    for(j=1;j<i;j++){
                        a[x+j][y-j] = pid;
                        put(x+j,y-j,pid,1);
                    }
                    break;
                }
                else if(a[x+i][y-i] == 0)
                    break;
            }
        }
    }
}


