#include "vs_othello.h"

void set_limit(n,arg)
int n;
char *arg[];
{
	int i;
	opt_d = 0;
	time_up = TIME_UP;
	if(n == 1)return;
	for(i=1;i<n-1;i++){
		if(strcmp(arg[i],"-t") == 0)
			time_up = atoi(arg[++i]);
		else if(strcmp(arg[i],"-d") == 0){
			strcpy(str,arg[++i]);
			opt_d = 1;
		}
	}
	if(i % 2 == 0){
		if(strcmp(arg[n],"-t") == 0)
			time_up = TIME_UP;
		else if(strcmp(arg[n],"-d") == 0){
			strcpy(str,NULL);
			opt_d = 1;
		}
	}
	if(time_up < 3)time_up = TIME_UP;
	if(time_up > 99)time_up = 99;
}

void set_board()
{
    static int i, j;
    for(i=0;i<8;i++){
        for(j=0;j<8;j++){
            a[i][j] = 0;
        }
    }
    a[3][3] = a[4][4] = 1;
    a[3][4] = a[4][3] = 2;
	last_x = last_y = -1;
    XClearWindow(d1,w1);
    XClearWindow(d2,w2);
    for(i=0;i<8;i++){
        for(j=0;j<8;j++){
            switch(a[i][j]){
                case 1 :
                    XCopyArea(d1, blackon1, w1, gc1, 0, 0, 50, 50, 50*i+50, 50*j+50);
                    XCopyArea(d2, blackon2, w2, gc2, 0, 0, 50, 50, 50*i+50, 50*j+50);
                    break;
                case 2 :
                    XCopyArea(d1, whiteon1, w1, gc1, 0, 0, 50, 50, 50*i+50, 50*j+50);
                    XCopyArea(d2, whiteon2, w2, gc2, 0, 0, 50, 50, 50*i+50, 50*j+50);
                    break;
                default :
                    XCopyArea(d1, nothing1, w1, gc1, 0, 0, 50, 50, 50*i+50, 50*j+50);
                    XCopyArea(d2, nothing2, w2, gc2, 0, 0, 50, 50, 50*i+50, 50*j+50);
                    break;
            }
        }
    }
    XFlush(d1);
    XFlush(d2);
    turn = 0;
}


