#include "vs_othello.h"
#include "bitmap/sen.xbm"
#include "bitmap/go.xbm"
#include "bitmap/te.xbm"

#define DOUBLECLICK 120000

void w1_saki()
{
    static int i,  j;
	static Pixmap p_sen, p_go, p_te;
	static unsigned long dsblue, lpink;
	static time_t time1,  time2,  old;
	static char sec[4];

	XAllocNamedColor(d1,cmap1,"LightPink1",&col,&c0);
    lpink = col.pixel;
    XAllocNamedColor(d1,cmap1,"DeepSkyBlue",&col,&c0);
    XSetForeground(d1, gc1, col.pixel);
    dsblue = col.pixel;
    p_sen = XCreatePixmapFromBitmapData(d1,p1,sen_bits,40,40,
                                  lpink, dsblue, DefaultDepth(d1,0));
    p_te = XCreatePixmapFromBitmapData(d1,p1,te_bits,40,40,
                                  lpink, dsblue, DefaultDepth(d1,0));
    XCopyArea(d1, p_sen, p1, gc1, 0, 0, 40, 40, 10, 55);
    XCopyArea(d1, p_te,  p1, gc1, 0, 0, 40, 40, 50, 55);
	XAllocNamedColor(d2,cmap2,"LightPink1",&col,&c0);
    lpink = col.pixel;
    XAllocNamedColor(d2,cmap2,"DeepSkyBlue",&col,&c0);
    XSetForeground(d2, gc2, col.pixel);
    dsblue = col.pixel;
    p_go = XCreatePixmapFromBitmapData(d2,w2,go_bits,40,40,
                                  dsblue, lpink, DefaultDepth(d2,0));
    p_te = XCreatePixmapFromBitmapData(d2,w2,te_bits,40,40,
                                  dsblue, lpink, DefaultDepth(d2,0));
    XCopyArea(d2, p_go, p2, gc2, 0, 0, 40, 40, 10, 55);
    XCopyArea(d2, p_te, p2, gc2, 0, 0, 40, 40, 50, 55);
    XCopyArea(d1, p1, w1, gc1, 0, 0, 100, 500, 500, 0);
    XCopyArea(d2, p2, w2, gc2, 0, 0, 100, 500, 500, 0);

	XSetFont(d1,gc1,XLoadFont(d1, F24));
	XSetFont(d2,gc2,XLoadFont(d2, F24));
    last_pass = 0;
    kuro_koma = shiro_koma = 2;
	put_koma_suu();
	XFlush(d1);
	XFlush(d2);
    while(turn < 60){
        if( (kuro_koma == 0) || (shiro_koma == 0) )turn = 1000;
		XCopyArea(d2,p2,w2,gc2,10,150,80,50,510,150);
		XAllocNamedColor(d2,cmap2,"LightPink4",&col,&c0);
		XSetForeground(d2, gc2, col.pixel);
		XDrawString(d2,w2,gc2,518,188,"Wait",4);
		XSetForeground(d2, gc2, black2);
		XDrawString(d2,w2,gc2,515,185,"Wait",4);
        XSync(d2,0);
		if(XCheckTypedEvent(d1,Expose,&e))redraw();
        XSync(d1,1);
		time(&time1);
        while(turn < 60){
            XDefineCursor(d1,w1,XCreateFontCursor(d1,XC_arrow));
            while(1){
                if(XCheckTypedEvent(d1,Expose,&e))redraw();
                if(XCheckTypedEvent(d2,Expose,&e)){
					redraw();
					XCopyArea(d2,p2,w2,gc2,10,150,80,50,510,150);
					XAllocNamedColor(d2,cmap2,"LightPink4",&col,&c0);
					XSetForeground(d2, gc2, col.pixel);
					XDrawString(d2,w2,gc2,518,188,"Wait",4);
					XSetForeground(d2, gc2, black2);
					XDrawString(d2,w2,gc2,515,185,"Wait",4);
				}
                if(XCheckTypedEvent(d1,ButtonPress,&e))break;
				time(&time2);
				if(time2 == old)continue;
				if(time2-time1 >= time_up){
					XSetFont(d1,gc1,XLoadFont(d1, F20));
					XCopyArea(d1,p1,w1,gc1,10,150,80,50,510,150);
					XAllocNamedColor(d1,cmap1,"RoyalBlue",&col,&c0);
					XSetForeground(d1, gc1, col.pixel);
					XDrawString(d1,w1,gc1,513,188,"Time up",7);
					XSetForeground(d1, gc1, black1);
					XDrawString(d1,w1,gc1,510,185,"Time up",7);
					t = 2;
					turn = 1000;
					break;
				}
				old = time2;
				sprintf(sec,"%2d",time_up-(time2-time1));
				XCopyArea(d1,p1,w1,gc1,10,150,80,50,510,150);
				XAllocNamedColor(d1,cmap1,"RoyalBlue",&col,&c0);
				XSetForeground(d1, gc1, col.pixel);
				XDrawString(d1,w1,gc1,533,188,sec,strlen(sec));
				XSetForeground(d1, gc1, black1);
				XDrawString(d1,w1,gc1,530,185,sec,strlen(sec));
				if(time_up-(time2-time1) < 4)XBell(d1,0);
				XFlush(d1);
            }
            if(e.type == ButtonPress){
                if( (x = e.xbutton.x / 50 - 1) < 0){
                    XBell(d1,0);
                    continue;
                }
                if( (y = e.xbutton.y / 50 - 1) < 0){;
                    XBell(d1,0);
                    continue;
                }
                if( (x > 8) && (y == 8) ){
                    usleep(DOUBLECLICK);
                    if(XCheckTypedEvent(d1,ButtonPress,&e)){
                        x = e.xbutton.x / 50 - 1;
                        y = e.xbutton.y / 50 - 1;
                        if( (x > 8) && (y == 8) )
                            game_close();
                    }
                }
				if( (x > 8) && (y == 7) ){
					usleep(DOUBLECLICK);
					if(XCheckTypedEvent(d1,ButtonPress,&e)){
						x = e.xbutton.x / 50 - 1;
						y = e.xbutton.y / 50 - 1;
						if( (x > 8) && (y == 7) ){
							t = 2;
							turn = 1000;
							break;
						}
					}
				}
                if( (x < 8) && (y < 8) ){
                    if(a[x][y] != 0){
                        XBell(d1,0);
                        continue;
                    }
                    if(rev_point(a,x,y,1)){
                        XDefineCursor(d1,w1,XCreateFontCursor(d1,XC_watch));
                        reverse(a,x,y,1);
                        turn++;
                        break;
                    }
                }
                if(x > 8){
                    if(y == 6){
                        if(pass(1)){
                            if(last_pass == turn){
                                turn = 1000;
                                break;
                            }
                            last_pass = turn;
							if( (last_x >= 0) && (last_y >= 0) ){
								XCopyArea(d1,whiteon1,w1,gc1,0,0,50,50,50+50*last_x,50+50*last_y);
								XCopyArea(d2,whiteon2,w2,gc2,0,0,50,50,50+50*last_x,50+50*last_y);
							}
							last_x = last_y = -1;
                            XDefineCursor(d1,w1,XCreateFontCursor(d1,XC_watch));
                            break;
                        }
                        XBell(d1,0);
                        continue;
                    }
                }
                XBell(d1,0);
                continue;
            }
        }
        if( (kuro_koma == 0) || (shiro_koma == 0) )turn = 1000;
		if(turn > 100)break;
		XCopyArea(d1,p1,w1,gc1,10,150,80,50,510,150);
		XAllocNamedColor(d1,cmap1,"RoyalBlue",&col,&c0);
		XSetForeground(d1, gc1, col.pixel);
		XDrawString(d1,w1,gc1,518,188,"Wait",4);
		XSetForeground(d1, gc1, black1);
		XDrawString(d1,w1,gc1,515,185,"Wait",4);
        XSync(d1,0);
		if(XCheckTypedEvent(d2,Expose,&e))redraw();
        XSync(d2,1);
		time(&time1);
        while(turn < 60){
            XDefineCursor(d2,w2,XCreateFontCursor(d2,XC_arrow));
            while(1){
                if(XCheckTypedEvent(d1,Expose,&e)){
					redraw();
					XCopyArea(d1,p1,w1,gc1,10,150,80,50,510,150);
					XAllocNamedColor(d1,cmap1,"RoyalBlue",&col,&c0);
					XSetForeground(d1, gc1, col.pixel);
					XDrawString(d1,w1,gc1,518,188,"Wait",4);
					XSetForeground(d1, gc1, black1);
					XDrawString(d1,w1,gc1,515,185,"Wait",4);
				}
                if(XCheckTypedEvent(d2,Expose,&e))redraw();
                if(XCheckTypedEvent(d2,ButtonPress,&e))break;
				time(&time2);
				if(time2 == old)continue;
				if(time2-time1 >= time_up){
					XSetFont(d2,gc2,XLoadFont(d2, F20));
					XCopyArea(d2,p2,w2,gc2,10,150,80,50,510,150);
					XAllocNamedColor(d2,cmap2,"LightPink4",&col,&c0);
					XSetForeground(d2, gc2, col.pixel);
					XDrawString(d2,w2,gc2,513,188,"Time up",7);
					XSetForeground(d2, gc2, black2);
					XDrawString(d2,w2,gc2,510,185,"Time up",7);
					t = 3;
					turn = 1000;
					break;
				}
				old = time2;
				sprintf(sec,"%2d",time_up-(time2-time1));
				XCopyArea(d2,p2,w2,gc2,10,150,80,50,510,150);
				XAllocNamedColor(d2,cmap2,"LightPink4",&col,&c0);
				XSetForeground(d2, gc2, col.pixel);
				XDrawString(d2,w2,gc2,533,188,sec,strlen(sec));
				XSetForeground(d2, gc2, black2);
				XDrawString(d2,w2,gc2,530,185,sec,strlen(sec));
				if(time_up-(time2-time1) < 4)XBell(d2,0);
				XFlush(d2);
            }
            if(e.type == ButtonPress){
                if( (x = e.xbutton.x / 50 - 1) < 0){
                    XBell(d2,0);
                    continue;
                }
                if( (y = e.xbutton.y / 50 - 1) < 0){;
                    XBell(d2,0);
                    continue;
                }
                if( (x > 8) && (y == 8) ){
                    usleep(DOUBLECLICK);
                    if(XCheckTypedEvent(d2,ButtonPress,&e)){
                        x = e.xbutton.x / 50 - 1;
                        y = e.xbutton.y / 50 - 1;
                        if( (x > 8) && (y == 8) )
                            game_close();
                    }
                }
				if( (x > 8) && (y == 7) ){
					usleep(DOUBLECLICK);
					if(XCheckTypedEvent(d2,ButtonPress,&e)){
						x = e.xbutton.x / 50 - 1;
						y = e.xbutton.y / 50 - 1;
						if( (x > 8) && (y == 7) ){
							t = 3;
							turn = 1000;
							break;
						}
					}
 				}
                if( (x < 8) && (y < 8) ){
                    if(a[x][y] != 0){
                        XBell(d2,0);
                        continue;
                    }
                    if(rev_point(a,x,y,2)){
                        XDefineCursor(d2,w2,XCreateFontCursor(d2,XC_watch));
                        reverse(a,x,y,2);
                        turn++;
                        break;
                    }
                }
                if(x > 8){
                    if(y == 6){
                        if(pass(2)){
                            if(last_pass == turn){
                                turn = 1000;
                                break;
                            }
                            last_pass = turn;
							if( (last_x >= 0) && (last_y >= 0) ){
								XCopyArea(d1,blackon1,w1,gc1,0,0,50,50,50+50*last_x,50+50*last_y);
								XCopyArea(d2,blackon2,w2,gc2,0,0,50,50,50+50*last_x,50+50*last_y);
							}
							last_x = last_y = -1;
                            XDefineCursor(d2,w2,XCreateFontCursor(d2,XC_watch));
                            break;
                        }
                        XBell(d2,0);
                        continue;
                    }
                }
                XBell(d2,0);
                continue;
            }
        }
    }
}

void w2_saki()
{
    static int i,  j;
	static Pixmap p_sen, p_go, p_te;
	static unsigned long dsblue, lpink;
	static time_t time1,  time2,  old;
	static char sec[4];

	XAllocNamedColor(d1,cmap1,"LightPink1",&col,&c0);
    lpink = col.pixel;
    XAllocNamedColor(d1,cmap1,"DeepSkyBlue",&col,&c0);
    XSetForeground(d1, gc1, col.pixel);
    dsblue = col.pixel;
    p_go = XCreatePixmapFromBitmapData(d1,p1,go_bits,40,40,
                                  lpink, dsblue, DefaultDepth(d1,0));
    p_te = XCreatePixmapFromBitmapData(d1,p1,te_bits,40,40,
                                  lpink, dsblue, DefaultDepth(d1,0));
    XCopyArea(d1, p_go, p1, gc1, 0, 0, 40, 40, 10, 55);
    XCopyArea(d1, p_te,  p1, gc1, 0, 0, 40, 40, 50, 55);
	XAllocNamedColor(d2,cmap2,"LightPink1",&col,&c0);
    lpink = col.pixel;
    XAllocNamedColor(d2,cmap2,"DeepSkyBlue",&col,&c0);
    XSetForeground(d2, gc2, col.pixel);
    dsblue = col.pixel;
    p_sen = XCreatePixmapFromBitmapData(d2,w2,sen_bits,40,40,
                                  dsblue, lpink, DefaultDepth(d2,0));
    p_te = XCreatePixmapFromBitmapData(d2,w2,te_bits,40,40,
                                  dsblue, lpink, DefaultDepth(d2,0));
    XCopyArea(d2, p_sen, p2, gc2, 0, 0, 40, 40, 10, 55);
    XCopyArea(d2, p_te, p2, gc2, 0, 0, 40, 40, 50, 55);
    XCopyArea(d1, p1, w1, gc1, 0, 0, 100, 500, 500, 0);
    XCopyArea(d2, p2, w2, gc2, 0, 0, 100, 500, 500, 0);

	XSetFont(d1,gc1,XLoadFont(d1, F24));
	XSetFont(d2,gc2,XLoadFont(d2, F24));
    last_pass = 0;
    kuro_koma = shiro_koma = 2;
	put_koma_suu();
	XFlush(d1);
	XFlush(d2);
    while(turn < 60){
        if( (kuro_koma == 0) || (shiro_koma == 0) )turn = 1000;
		XCopyArea(d1,p1,w1,gc1,10,150,80,50,510,150);
		XAllocNamedColor(d1,cmap1,"RoyalBlue",&col,&c0);
		XSetForeground(d1, gc1, col.pixel);
		XDrawString(d1,w1,gc1,518,188,"Wait",4);
		XSetForeground(d1, gc1, black1);
		XDrawString(d1,w1,gc1,515,185,"Wait",4);
        XSync(d1,0);
		if(XCheckTypedEvent(d2,Expose,&e))redraw();
        XSync(d2,1);
		time(&time1);
        while(turn < 60){
            XDefineCursor(d2,w2,XCreateFontCursor(d2,XC_arrow));
            while(1){
                if(XCheckTypedEvent(d1,Expose,&e)){
					redraw();
					XCopyArea(d1,p1,w1,gc1,10,150,80,50,510,150);
					XAllocNamedColor(d1,cmap1,"RoyalBlue",&col,&c0);
					XSetForeground(d1, gc1, col.pixel);
					XDrawString(d1,w1,gc1,518,188,"Wait",4);
					XSetForeground(d1, gc1, black1);
					XDrawString(d1,w1,gc1,515,185,"Wait",4);
				}
                if(XCheckTypedEvent(d2,Expose,&e))redraw();
                if(XCheckTypedEvent(d2,ButtonPress,&e))break;
				time(&time2);
				if(time2 == old)continue;
				if(time2-time1 >= time_up){
					XSetFont(d2,gc2,XLoadFont(d2, F20));
					XCopyArea(d2,p2,w2,gc2,10,150,80,50,510,150);
					XAllocNamedColor(d2,cmap2,"LightPink4",&col,&c0);
					XSetForeground(d2, gc2, col.pixel);
					XDrawString(d2,w2,gc2,513,188,"Time up",7);
					XSetForeground(d2, gc2, black2);
					XDrawString(d2,w2,gc2,510,185,"Time up",7);
					t = 4;
					turn = 1000;
					break;
				}
				old = time2;
				sprintf(sec,"%2d",time_up-(time2-time1));
				XCopyArea(d2,p2,w2,gc2,10,150,80,50,510,150);
				XAllocNamedColor(d2,cmap2,"LightPink4",&col,&c0);
				XSetForeground(d2, gc2, col.pixel);
				XDrawString(d2,w2,gc2,533,188,sec,strlen(sec));
				XSetForeground(d2, gc2, black2);
				XDrawString(d2,w2,gc2,530,185,sec,strlen(sec));
				if(time_up-(time2-time1) < 4)XBell(d2,0);
				XFlush(d2);
            }
            if(e.type == ButtonPress){
                if( (x = e.xbutton.x / 50 - 1) < 0){
                    XBell(d2,0);
                    continue;
                }
                if( (y = e.xbutton.y / 50 - 1) < 0){;
                    XBell(d2,0);
                    continue;
                }
                if( (x > 8) && (y == 8) ){
                    usleep(DOUBLECLICK);
                    if(XCheckTypedEvent(d2,ButtonPress,&e)){
                        x = e.xbutton.x / 50 - 1;
                        y = e.xbutton.y / 50 - 1;
                        if( (x > 8) && (y == 8) )
                            game_close();
                    }
                }
				if( (x > 8) && (y == 7) ){
					usleep(DOUBLECLICK);
					if(XCheckTypedEvent(d2,ButtonPress,&e)){
						x = e.xbutton.x / 50 - 1;
						y = e.xbutton.y / 50 - 1;
						if( (x > 8) && (y == 7) ){
							t = 4;
							turn = 1000;
							break;
						}
					}
				}
                if( (x < 8) && (y < 8) ){
                    if(a[x][y] != 0){
                        XBell(d2,0);
                        continue;
                    }
                    if(rev_point(a,x,y,1)){
                        XDefineCursor(d2,w2,XCreateFontCursor(d2,XC_watch));
                        reverse(a,x,y,1);
                        turn++;
                        break;
                    }
                }
                if(x > 8){
                    if(y == 6){
                        if(pass(1)){
                            if(last_pass == turn){
                                turn = 1000;
                                break;
                            }
                            last_pass = turn;
							if( (last_x >= 0) && (last_y >= 0) ){
								XCopyArea(d1,whiteon1,w1,gc1,0,0,50,50,50+50*last_x,50+50*last_y);
								XCopyArea(d2,whiteon2,w2,gc2,0,0,50,50,50+50*last_x,50+50*last_y);
							}
							last_x = last_y = -1;
                            XDefineCursor(d2,w2,XCreateFontCursor(d2,XC_watch));
                            break;
                        }
                        XBell(d2,0);
                        continue;
                    }
                }
                XBell(d2,0);
                continue;
            }
		}
        if( (kuro_koma == 0) || (shiro_koma == 0) )turn = 1000;
		if(turn > 100)break;
		XCopyArea(d2,p2,w2,gc2,10,150,80,50,510,150);
		XAllocNamedColor(d2,cmap2,"LightPink4",&col,&c0);
		XSetForeground(d2, gc2, col.pixel);
		XDrawString(d2,w2,gc2,518,188,"Wait",4);
		XSetForeground(d2, gc2, black2);
		XDrawString(d2,w2,gc2,515,185,"Wait",4);
        XSync(d2,0);
		if(XCheckTypedEvent(d1,Expose,&e))redraw();
        XSync(d1,1);
		time(&time1);
        while(turn < 60){
            XDefineCursor(d1,w1,XCreateFontCursor(d1,XC_arrow));
            while(1){
                if(XCheckTypedEvent(d1,ButtonPress,&e))break;
                if(XCheckTypedEvent(d1,Expose,&e))redraw();
                if(XCheckTypedEvent(d2,Expose,&e)){
					redraw();
					XCopyArea(d2,p2,w2,gc2,10,150,80,50,510,150);
					XAllocNamedColor(d2,cmap2,"LightPink4",&col,&c0);
					XSetForeground(d2, gc2, col.pixel);
					XDrawString(d2,w2,gc2,518,188,"Wait",4);
					XSetForeground(d2, gc2, black2);
					XDrawString(d2,w2,gc2,515,185,"Wait",4);
				}
				time(&time2);
				if(time2 == old)continue;
				if(time2-time1 >= time_up){
					XSetFont(d1,gc1,XLoadFont(d1, F20));
					XCopyArea(d1,p1,w1,gc1,10,150,80,50,510,150);
					XAllocNamedColor(d1,cmap1,"RoyalBlue",&col,&c0);
					XSetForeground(d1, gc1, col.pixel);
					XDrawString(d1,w1,gc1,513,188,"Time up",7);
					XSetForeground(d1, gc1, black1);
					XDrawString(d1,w1,gc1,510,185,"Time up",7);
					t = 5;
					turn = 1000;
					break;
				}
				old = time2;
				sprintf(sec,"%2d",time_up-(time2-time1));
				XCopyArea(d1,p1,w1,gc1,10,150,80,50,510,150);
				XAllocNamedColor(d1,cmap1,"RoyalBlue",&col,&c0);
				XSetForeground(d1, gc1, col.pixel);
				XDrawString(d1,w1,gc1,533,188,sec,strlen(sec));
				XSetForeground(d1, gc1, black1);
				XDrawString(d1,w1,gc1,530,185,sec,strlen(sec));
				if(time_up-(time2-time1) < 4)XBell(d1,0);
				XFlush(d1);
            }
            if(e.type == ButtonPress){
                if( (x = e.xbutton.x / 50 - 1) < 0){
                    XBell(d1,0);
                    continue;
                }
                if( (y = e.xbutton.y / 50 - 1) < 0){;
                    XBell(d1,0);
                    continue;
                }
                if( (x > 8) && (y == 8) ){
                    usleep(DOUBLECLICK);
                    if(XCheckTypedEvent(d1,ButtonPress,&e)){
                        x = e.xbutton.x / 50 - 1;
                        y = e.xbutton.y / 50 - 1;
                        if( (x > 8) && (y == 8) )
                            game_close();
                    }
                }
				if( (x > 8) && (y == 7) ){
					usleep(DOUBLECLICK);
					if(XCheckTypedEvent(d1,ButtonPress,&e)){
						x = e.xbutton.x / 50 - 1;
						y = e.xbutton.y / 50 - 1;
						if( (x > 8) && (y == 7) ){
							t = 5;
							turn = 1000;
							break;
						}
					}
				}
                if( (x < 8) && (y < 8) ){
                    if(a[x][y] != 0){
                        XBell(d1,0);
                        continue;
                    }
                    if(rev_point(a,x,y,2)){
                        XDefineCursor(d1,w1,XCreateFontCursor(d1,XC_watch));
                        reverse(a,x,y,2);
                        turn++;
                        break;
                    }
                }
                if(x > 8){
                    if(y == 6){
                        if(pass(2)){
                            if(last_pass == turn){
                                turn = 1000;
                                break;
                            }
                            last_pass = turn;
							if( (last_x >= 0) && (last_y >= 0) ){
								XCopyArea(d1,blackon1,w1,gc1,0,0,50,50,50+50*last_x,50+50*last_y);
								XCopyArea(d2,blackon2,w2,gc2,0,0,50,50,50+50*last_x,50+50*last_y);
							}
							last_x = last_y = -1;
                            XDefineCursor(d1,w1,XCreateFontCursor(d1,XC_watch));
                            break;
                        }
                        XBell(d1,0);
                        continue;
                    }
                }
                XBell(d1,0);
                continue;
            }
        }
    }
}

int pass(pid)
int pid;
{
    static int i,  j;
    for(i=0;i<8;i++){
        for(j=0;j<8;j++){
            if(a[i][j] != 0);
            else if(rev_point(a,i,j,pid))return 0;
        }
    }
    return 1;
}

int put_koma_suu()
{
    static char komasuu1[5],  komasuu2[5];

    sprintf(komasuu1,"%2d\0",kuro_koma);
    sprintf(komasuu2,"%2d\0",shiro_koma);
    XSetFont(d1,gc1,XLoadFont(d1, F24));
    XAllocNamedColor(d1,cmap1,"DeepSkyBlue",&col,&c0);
    XSetForeground(d1, gc1, col.pixel);
    XFillRectangle(d1,p_koma_suu1,gc1,0,0,40,130);
    XAllocNamedColor(d1,cmap1,"RoyalBlue",&col,&c0);
    XSetForeground(d1, gc1, col.pixel);
    XDrawString(d1,p_koma_suu1,gc1,3,43,komasuu1,strlen(komasuu1));
    XDrawString(d1,p_koma_suu1,gc1,3,113,komasuu2,strlen(komasuu2));
    XSetForeground(d1, gc1, black1);
    XDrawString(d1,p_koma_suu1,gc1,0,40,komasuu1,strlen(komasuu1));
    XDrawString(d1,p_koma_suu1,gc1,0,110,komasuu2,strlen(komasuu2));
    XCopyArea(d1,p_koma_suu1,w1,gc1,0,0,40,130,550,210);
    XFlush(d1);

    XSetFont(d2,gc2,XLoadFont(d2, F24));
    XAllocNamedColor(d2,cmap2,"LightPink1",&col,&c0);
    XSetForeground(d2, gc2, col.pixel);
    XFillRectangle(d2,p_koma_suu2,gc2,0,0,40,130);
    XAllocNamedColor(d2,cmap2,"LightPink4",&col,&c0);
    XSetForeground(d2, gc2, col.pixel);
    XDrawString(d2,p_koma_suu2,gc2,3,43,komasuu1,strlen(komasuu1));
    XDrawString(d2,p_koma_suu2,gc2,3,113,komasuu2,strlen(komasuu2));
    XSetForeground(d2, gc2, black2);
    XDrawString(d2,p_koma_suu2,gc2,0,40,komasuu1,strlen(komasuu1));
    XDrawString(d2,p_koma_suu2,gc2,0,110,komasuu2,strlen(komasuu2));
    XCopyArea(d2,p_koma_suu2,w2,gc2,0,0,40,130,550,210);
    XFlush(d2);
}

int game_close()
{
    XDestroyWindow(d2,w2);
    XDestroyWindow(d1,w1);
    XCloseDisplay(d2);
    XCloseDisplay(d1);
    exit(1);
}
/*  EOF */
